=begin ###################################################################################
   Copyright 2010 Christopher Nicholson-Sauls

   Licensed under the Apache License, Version 2.0 (the "License");
   you may not use this file except in compliance with the License.
   You may obtain a copy of the License at

       http://www.apache.org/licenses/LICENSE-2.0

   Unless required by applicable law or agreed to in writing, software
   distributed under the License is distributed on an "AS IS" BASIS,
   WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
   See the License for the specific language governing permissions and
   limitations under the License.
=end #####################################################################################

##########################################################################################
#   
#
require 'pathname'

##########################################################################################
#   
#
module Refuge::Commands

    ##################################################################################
    #   
    #
    @@command = ARGV.find {| elem | elem =~ /^[a-z][a-z\-]+$/i }
    @@command ||= Refuge::DEFAULT_COMMAND
    
    ##################################################################################
    #   
    #
    @@path = Pathname.new( Refuge::LIBBASE_COMMANDS + @@command.downcase )

    ##################################################################################
    #   
    #
    unless require @@path
        Refuge::exit( :general, "command script could not be loaded: '#{ @@command }'" )
    end
    @@current = Refuge::Commands::Impl.new

    ##################################################################################
    #   
    #
    module_function

    ##################################################################################
    #   
    #
    def command ;@@command ;end
    def current ;@@current ;end
    def path    ;@@path    ;end

end # module Refuge::Commands

##########################################################################################
#   
#
class Refuge::Commands::Base
    
    STANDARD_API = {
    }

    STANDARD_API.each_pair do | msg, params |
        signature = "#{ msg }( #{ params } ) "
        class_eval %Q{
            def #{ signature }
                Refuge::exit :cmd_not_impl, '#{ signature }'
            end
        }
    end

end # end class Refuge::Native::Base
