=begin ###################################################################################
   Copyright 2010 Christopher Nicholson-Sauls

   Licensed under the Apache License, Version 2.0 (the "License");
   you may not use this file except in compliance with the License.
   You may obtain a copy of the License at

       http://www.apache.org/licenses/LICENSE-2.0

   Unless required by applicable law or agreed to in writing, software
   distributed under the License is distributed on an "AS IS" BASIS,
   WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
   See the License for the specific language governing permissions and
   limitations under the License.
=end #####################################################################################

##########################################################################################
#   
#
require 'pathname'
require 'rbconfig'
require 'singleton'

##########################################################################################
#   
#
module Refuge::Native

    ##################################################################################
    #   
    #
    module_function
    
    ##################################################################################
    #   
    #
    def instance
        @@success ||= require Refuge::LIBBASE_NATIVE + RbConfig::CONFIG[ 'host_os' ]
        Refuge::exit :os_not_supported unless @@success
        Impl.instance
    end

end # module Refuge::Native

##########################################################################################
#   
#
class Refuge::Native::Base
    
    STANDARD_API = {
        :config_paths   => '',
        :fetch          => 'path'
    }

    STANDARD_API.each_pair do | msg, params |
        signature = "#{ msg }( #{ params } ) "
        class_eval %Q{
            def #{ signature }
                Refuge::exit :native_not_impl, '#{ signature }'
            end
        }
    end

end # end class Refuge::Native::Base

##########################################################################################
#   
#
class Refuge::Native::Impl < Refuge::Native::Base
    
    include Singleton

end # end class Refuge::Native::Impl

