=begin ###################################################################################
   Copyright 2010 Christopher Nicholson-Sauls

   Licensed under the Apache License, Version 2.0 (the "License");
   you may not use this file except in compliance with the License.
   You may obtain a copy of the License at

       http://www.apache.org/licenses/LICENSE-2.0

   Unless required by applicable law or agreed to in writing, software
   distributed under the License is distributed on an "AS IS" BASIS,
   WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
   See the License for the specific language governing permissions and
   limitations under the License.
=end #####################################################################################

##########################################################################################
#   
#
require 'optparse'
require 'ostruct'
require 'singleton'

##########################################################################################
#   
#
module Refuge;

    DEFAULT_SETTINGS = {
        :help       => false,
        :verbose    => false
    }
    
    COMMON_OPTIONS = {
        :verbose    => 'Run with verbose output.'
    }
    
    @@options = OpenStruct.new DEFAULT_SETTINGS
    
    module_function
    
    def options; @@options; end

    def option_parser
        @@option_parser ||= OptionParser.new do | op |
            op.banner = "Usage: #{ $0 } [common-options] command [options]"
            
            op.separator ''
            op.separator 'Common Options:'
            
            op.on( '-?', '--help', 'Show quick usage information.' ) do | x |
                @@options.help = x
            end
            
            COMMON_OPTIONS.sort.each do | tag, desc |
                op.on( "-#{ tag.to_s[ 0, 1 ] }", "--[no-]#{ tag }", desc ) do | x |
                    #@@options.__send__( "#{ tag }=", x )
                    @@options[ tag ] = x
                end
            end
        end
    end

    def update_options ( table )
        table.each_pair do | key, value |
            #@@options.__send__( "#{ key }=", value )
            @@options[ key ] = value
        end
    end
        
end; # 
